package components {
import mx.controls.Image;

import spark.components.RichText;
import spark.components.TextInput;
import spark.components.TitleWindow;

public final class FXTile extends TitleWindow {
    [Bindable]
    public var buy:HighlightButton;
    [Bindable]
    public var sell:HighlightButton;
    [Bindable]
    public var graphIcon:Image;

    [Embed(source="bar_chart.png")]
    [Bindable]
    public var imgCls:Class;

    [Bindable]
    public var tradeNumber:TextInput;

    public function FXTile(indexName:String, bid:Number, offer:Number) {
        super();
        id = indexName.replace("/", "");
        title = indexName;
        setStyle("backgroundColor", "#696969");
        setStyle("chromeColor", "#777777");
        buy = new HighlightButton();

        buy.setStyle("chromeColor", "#313131");
        buy.x = 10;
        buy.y = 10;
        buy.height = 88;
        buy.width = 96;
        buy.updateButtonSpot(bid);
        buy.label = "buy";


        tradeNumber = new TextInput();
        tradeNumber.x = 10;
        tradeNumber.y = 105;
        tradeNumber.width = 96;
        tradeNumber.setStyle("contentBackgroundAlpha", "0.0");
        tradeNumber.text = "1000";
        tradeNumber.enabled = true;
        tradeNumber.bottom = 10;

        var currency:RichText = new RichText();
        currency.text = indexName.split("/")[0];
        currency.verticalCenter = true;
        currency.x = tradeNumber.x + 145;
        currency.y = tradeNumber.y;
        currency.bottom = 14;


        sell = new HighlightButton();
        sell.label = "sell";
        sell.x = 120;
        sell.y = 10;
        sell.height = 88;
        sell.width = 96;
        sell.setStyle("chromeColor", "#313131");
        sell.updateButtonSpot(offer);


        graphIcon = new Image();
        graphIcon.source = imgCls;
        graphIcon.width = 20;
        graphIcon.height = 20;
        graphIcon.x = 205;
        graphIcon.y = 120;
        graphIcon.useHandCursor = true;
        graphIcon.buttonMode = true;


        this.addElementAt(buy, 0);
        this.addElementAt(sell, 1);
        this.addElementAt(currency, 2);
        this.addElementAt(tradeNumber, 3);
        this.addElementAt(graphIcon, 4);

    }

    public function addSellEventListener(evtType:String, evtListener:Function):void {
        sell.addEventListener(evtType, evtListener);
    }

    public function getTradeNumber():String {
        return this.tradeNumber.text;
    }

    public function addBuyEventListener(evtType:String, evtListener:Function):void {
        buy.addEventListener(evtType, evtListener);
    }

    public function addImageEventListener(evtType:String, evtListener:Function):void {
        graphIcon.addEventListener(evtType, evtListener);
    }
}
}