package components {
import flash.events.*;
import flash.utils.Timer;

import flashx.textLayout.elements.ParagraphElement;
import flashx.textLayout.elements.SpanElement;
import flashx.textLayout.elements.TextFlow;

import mx.controls.Label;

import spark.components.supportClasses.ButtonBase;

public class HighlightButton extends ButtonBase {

    [SkinPart]
    public var leftLabel:Label;

    [SkinPart]
    public var rightLabel:Label;

    [SkinPart]
    public var centerLabel:Label;

    [Bindable]
    public var leftText:String;
    [Bindable]
    public var rightText:String;
    [Bindable]
    public var centerText:String;

    [Bindable]
    public var textFlow:TextFlow = new TextFlow();

    private var timer:Timer = new Timer(5000, 0);

    public function HighlightButton() {
        super();
        timer.addEventListener(TimerEvent.TIMER, reset);
        createSpotFormatting();
    }

    public function reset(event:TimerEvent):void {
        setStyle("chromeColor", "#313131");
    }

    public function highlight(color:String):void {
        setStyle("chromeColor", color);
        timer.reset();
        timer.start();
    }

    public function createSpotFormatting():void {
        var paragraph1:ParagraphElement = new ParagraphElement();
        var subscriptSpan:SpanElement = new SpanElement();
        var normalSpan:SpanElement = new SpanElement();
        var superscriptSpan:SpanElement = new SpanElement();


        subscriptSpan.baselineShift = "subscript";
        paragraph1.addChild(subscriptSpan);
        paragraph1.addChild(normalSpan);
        normalSpan.fontWeight = "bold";
        superscriptSpan.baselineShift = "superscript";
        paragraph1.addChild(superscriptSpan);
        textFlow.addChild(paragraph1);
    }

    public function updateButtonSpot(price:Number):void {
        var priceString:String = price.toString();
        while (priceString.length < 7) {
            priceString = priceString + "0";
        }
        var p:ParagraphElement = textFlow.getChildAt(0) as ParagraphElement;
        var subscriptSpan:SpanElement = p.getChildAt(0) as SpanElement;
        subscriptSpan.text = priceString.substr(0, 4);
        subscriptSpan = p.getChildAt(1) as SpanElement;
        subscriptSpan.text = priceString.substr(4, 2);
        subscriptSpan = p.getChildAt(2) as SpanElement;
        subscriptSpan.text = priceString.substr(6, 1);
    }

    protected override function partAdded(partName:String, instance:Object):void {
        super.partAdded(partName, instance);
        if (instance === leftLabel) {
            leftLabel.text = leftText;
        }
        if (instance === rightLabel) {
            rightLabel.text = rightText;
        }
        if (instance === centerLabel) {
            centerLabel.text = centerText;
        }
    }
}
}