package components {
import flash.display.Graphics;
import flash.display.Shape;
import flash.display.Sprite;

import mx.controls.DataGrid;
import mx.controls.listClasses.ListBaseContentHolder;
import mx.core.FlexShape;

public class MyDataGrid extends DataGrid {
    public function MyDataGrid() {
        super();
    }

    override protected function drawRowBackground(s:Sprite, rowIndex:int, y:Number, height:Number, color:uint, dataIndex:int):void {
        var contentHolder:ListBaseContentHolder = ListBaseContentHolder(s.parent);
        var background:Shape;
        if (rowIndex < s.numChildren) {
            background = Shape(s.getChildAt(rowIndex));
        } else {
            background = new FlexShape();
            background.name = "background";
            s.addChild(background);
        }

        background.y = y;

        // Height is usually as tall is the items in the row, but not if
        // it would extend below the bottom of listContent
        var heightCalc:Number = Math.min(height, contentHolder.height - y);

        var g:Graphics = background.graphics;
        g.clear();
        g.beginFill(0xFFFFFF, getStyle("backgroundAlpha"));
        g.drawRect(0, 0, contentHolder.width, heightCalc);
        g.endFill();
    }
}
}
