#include "nAPIConnectionListener.h"

#include <string>
#include <map>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nRealmACLEntry;
class nConnectionDetails;
class nACL;
class nLeafNode;
class nServiceNode;
class nRealmNode;

namespace apps {

using namespace com::pcbsys::nirvana::nAdminAPI;
using namespace com::pcbsys::foundation::fbase;
using namespace Poco;

class connectionwatch;

class nChannelWatch : public nAPIConnectionListener {
  private:
    nLeafNode *m_pChannel;
    connectionwatch *m_pWatcher;

  public:
    nChannelWatch(nLeafNode *pChan, connectionwatch *pWatch);
    virtual void add(nConnectionDetails *pDetails);
    virtual void del(nConnectionDetails *pDetails);
};

class nServiceWatch : public nAPIConnectionListener {
  private:
    nServiceNode *m_pService;
    connectionwatch *m_pWatcher;

  public:
    nServiceWatch(nServiceNode *pService, connectionwatch *pWatch);
    virtual void add(nConnectionDetails *pDetails);
    virtual void del(nConnectionDetails *pDetails);
};

class nRealmWatch : public nAPIConnectionListener {
  private:
    connectionwatch *m_pWatcher;

  public:
    nRealmWatch(connectionwatch *pWatch);
    virtual void add(nConnectionDetails *pDetails);
    virtual void del(nConnectionDetails *pDetails);
};

}
}
}
}
}
