#include "Observer.h"
#include "fSortedList.h"

#include "Poco/Mutex.h"

#include <string>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nNode;
class nRealmNode;
class nConnectionDetails;

namespace apps {

using namespace com::pcbsys::foundation::fbase;
using namespace com::pcbsys::foundation::collections;
using namespace Poco;

class connectionwatch : public Observer {
  public:
    connectionwatch(int argc, char** argv);

    virtual void update(Observable *pObs, void *pObj);

  private:
    void processArgs(int argc, char** argv);
    virtual void getOptions(int argc, char** argv);
    void registerNode(nRealmNode *pNode);
    void registerNodes(fSortedList<std::string, nNode*> nodes);
    static void Usage();
    void newConnection(const std::string& target, nConnectionDetails *pCd);
    void delConnection(const std::string& target, nConnectionDetails *pCd);

    std::string m_realmUrl;
    Mutex m_newConnectionMutex;

    friend class nChannelWatch;
    friend class nServiceWatch;
    friend class nRealmWatch;
};

}
}
}
}
}
