/*
    About: Copyright & License

    Copyright 1999-2011 (c) My-Channels
    Copyright (c) 2012-2014 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.

    Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.

*/

////////////////////////////////////////////////////////////////////
// Misc. Application specific -  Window resizing compatibility etc.
////////////////////////////////////////////////////////////////////

$(function () {
    isLoaded();
});

function resizeChatMessageDiv() {
    //var isiPad = navigator.userAgent.match(/iPad/i) != null;

// For use within iPad developer UIWebView
// Thanks to Andrew Hedges!
    var ua = navigator.userAgent;
    var isiPad = /iPad/i.test(ua) || /iPhone OS 3_1_2/i.test(ua) || /iPhone OS 3_2_2/i.test(ua) || navigator.userAgent.match(/iPhone/i);

    //if((navigator.userAgent.match(/iPhone/i)) ||
    //(navigator.userAgent.match(/iPod/i))) {

    var cr = document.getElementById("chatroom");
    var bph = $('div.outer-center').layout().state.south.size;
    var chh = parseInt(document.getElementById("ChatHeader").style.height) || 0;
    var ciph = parseInt(document.getElementById("ChatInputPane").height) || 0;
    cr.style.height = (Math.max(0, bph - (66))) + "px";
    document.getElementById("tradesdiv").style.height = (Math.max(0, bph - (23))) + "px";
    cr.scrollTop = cr.scrollHeight;
    window.status = bph + " " + chh + " " + ciph + " " + cr.style.height;
    var winH = 460;
    if (document.body && document.body.offsetWidth) {
        winH = document.body.offsetHeight;
    }
    if (document.compatMode == 'CSS1Compat' &&
        document.documentElement &&
        document.documentElement.offsetWidth) {
        winH = document.documentElement.offsetHeight;
    }
    if (window.innerWidth && window.innerHeight) {
        winH = window.innerHeight;
    }
    if (isiPad) {
    } else {
        cr = document.getElementById("contentPanel");
        bph = $('body').layout().state.north.size;
        cr.style.height = (winH - bph - 25) + "px";
    }
}

var outerLayout, innerLayout;

$(document).ready(function () {

////////////////////////////////////////////////////////////////////
// Splitter setup
////////////////////////////////////////////////////////////////////
    outerLayout = $('body').layout({
        center__paneSelector:".outer-center", west__paneSelector:".outer-west", east__paneSelector:".outer-east", west__size:"30%", east__size:'20%', spacing_open:8 // ALL panes, spacing_closed:12 // ALL panes, north__spacing_open:0, north__spacing_open:0, north__maxSize:200, south__maxSize:400, west__height:"100%", onresize:resizeChatMessageDiv, west__resizerCursor:"col-resize"
    });

    innerLayout = $('div.outer-center').layout({
        center__paneSelector:".inner-center", west__paneSelector:".inner-west", east__paneSelector:".inner-east", south__paneSelector:".inner-south", south__size:'30%', west__size:75, east__size:75, spacing_open:8  // ALL panes, spacing_closed:8  // ALL panes, west__spacing_closed:12, east__spacing_closed:12, onresize:resizeChatMessageDiv, south__resizerCursor:"row-resize"
    });

    nestedLayout = $('div.inner-south').layout({
        center__paneSelector:".nested-center", west__paneSelector:".nested-west", east__paneSelector:".nested-east", south__paneSelector:".nested-south", west__size:75, east__size:"30%", spacing_open:8  // ALL panes, spacing_closed:8  // ALL panes, west__spacing_closed:12, east__spacing_closed:12, onresize:resizeChatMessageDiv, east__resizerCursor:"col-resize"
    });

});

function showUIMessage(message) {
    getMessageAreaDiv().innerHTML = message;
    document.getElementById("UIOverlayOuter").style.display = "";
}

function hideUIMessage() {
    try {
        document.getElementById("UIOverlayOuter").style.display = "none";
    } catch (ex) {
    }
}

function getMessageAreaDiv() {
    try {
        var uimessagediv = document.getElementById("UIMessage");
        if (uimessagediv == null) setupMessageAreaDiv();
        return document.getElementById("UIMessage");
    } catch (ex) {
        setupMessageAreaDiv();
        return document.getElementById("UIMessage");
    }
}

function setupMessageAreaDiv() {
    var outerdiv = document.createElement('div');
    outerdiv.id = "UIOverlayOuter";

    var middlediv = document.createElement('div');
    middlediv.id = "UIOverlayMiddle";

    var newdiv = document.createElement("div");
    newdiv.id = "UIMessage";

    var waitspan = document.createElement("div");
    waitspan.id = "UIWait";

    middlediv.appendChild(newdiv);
    middlediv.appendChild(waitspan);

    outerdiv.appendChild(middlediv);
    //document.body.appendChild(outerdiv);
    document.body.insertBefore(outerdiv, document.body.firstChild)

}

function updateStatus(message) {
    window.status = message;
}